#ifndef UTILITIEC_REGEX_H
#define UTILITIEC_REGEX_H

#include "match_struct.h"
#include "regex_struct.h"

#include "../StringView/StringView.h"

int Regex_Create(Regex* target, allocator_t* allocator);
void Regex_Destroy(Regex* regex);

int Regex_Compile(Regex* regex, StringView source);

/*!
   @brief Find the first match
   @param regex this
   @param string string
   @param match out, storage for the match. Caller is responsible for deletion
   @return EXIT_SUCCESS, EXIT_FAILURE, EDESTADDRREQ, ENOMEM
*/
int Regex_FirstMatch(Regex* regex, StringView string, RegexMatch* match);

/*!
   @brief Find All matches of [regex] within [string] and place them in [matches]
   @param regex this
   @param string string
   @param matches out, storage, caller is responsible for deletion
   @return EXIT_SUCCESS, EXIT_FAILURE, EDESTADDRREQ
*/
int Regex_FindAll(Regex* regex, StringView string, DynamicArray* matches);

#endif
